// PipeSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PipeSample.h"
#include "PipeSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PROVIDER_WAIT_TIME	3000

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPipeSampleDlg dialog

CPipeSampleDlg::CPipeSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPipeSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPipeSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPipeSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPipeSampleDlg)
	DDX_Control(pDX, IDC_EDIT_STATUS, m_Status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPipeSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CPipeSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStopServer)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStartServer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPipeSampleDlg message handlers

BOOL CPipeSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_hPipeEvent = NULL;
	m_hPipeThread = NULL;
	m_PipeHandle = NULL;

	CWnd * pWnd = NULL;

	pWnd = CWnd::FindWindow(NULL, _T("Pipe sample server"));

	if(!pWnd)
		this->SetWindowText(_T("Pipe sample server"));
	else
		this->SetWindowText(_T("Pipe sample client"));

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPipeSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPipeSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPipeSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPipeSampleDlg::OnButtonConnect() 
{
	CString szPipeName;
	szPipeName = _T("\\\\.\\pipe\\PipeTest");

	BOOL bret = FALSE;
	
	//first we will try to connect to the exising PIPE
	bret = ::WaitNamedPipe((LPCSTR)szPipeName,PROVIDER_WAIT_TIME);
	//the named 
	if(bret == FALSE)
	{
		ShowLastError();
		return;
	}
	else
	{
		//the PIPE is available so we will do the rest of the work in a thread
		ShowLastError("PIPE is available for connection");
		BOOL flg;
		DWORD dwWrite;

		CString szPipeUpdate;
		
		HANDLE hPipeHandle = ::CreateFile((LPCSTR)szPipeName,GENERIC_WRITE,0,NULL,
			OPEN_EXISTING,0,NULL);
		
		szPipeUpdate = _T("WM_USER_MESSAGE");
		
		flg = WriteFile(hPipeHandle, szPipeUpdate, strlen(szPipeUpdate), &dwWrite, NULL);

		if (FALSE == flg)
			ShowLastError("Sending string : " + szPipeUpdate + " Failed");
		else
			ShowLastError("Sending string : " + szPipeUpdate);

		CloseHandle(hPipeHandle);
	}
}

void CPipeSampleDlg::OnButtonStartServer() 
{
	// TODO: Add your control notification handler code here

	CString szPipeName;
	szPipeName = _T("\\\\.\\pipe\\PipeTest");
	
	HANDLE hPipeHandle = ::CreateNamedPipe((LPCSTR)szPipeName,PIPE_ACCESS_DUPLEX|FILE_FLAG_OVERLAPPED,
		PIPE_TYPE_MESSAGE| PIPE_WAIT,1,MAX_PATH,MAX_PATH,PROVIDER_WAIT_TIME,NULL);

	if(INVALID_HANDLE_VALUE == hPipeHandle)
	{
		ShowLastError();
	}
	else
	{
		m_PipeHandle = hPipeHandle;
		ShowLastError("Server successfully started and waiting for the client to send data");
		CreatePipeThread();
	}
}

void CPipeSampleDlg::ShowLastError(CString szMsg)
{
	if(szMsg == _T(""))
	{
		CString szStatus = _T("");
		LPVOID lpMsgBuf;
		if(FormatMessage( //For getting the system message
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),								// Get the error code. 
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),	// Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL ))
		{
			CString szError = (LPCTSTR)lpMsgBuf;
			m_Status.GetWindowText(szStatus);
			szStatus += szError;
			m_Status.SetWindowText(szStatus);
		}
		LocalFree( lpMsgBuf );
	}
	else
	{
		CString szStatus = _T("");
		m_Status.GetWindowText(szStatus);
		szStatus += szMsg;
		m_Status.SetWindowText(szStatus + "\r\n");
	}
	m_Status.SetSel(0,m_Status.GetWindowTextLength());
}

UINT CPipeSampleDlg::StartPipeThread(LPVOID lpData)
{
	CPipeSampleDlg *pPipeDlg = (CPipeSampleDlg*)lpData;

	while(TRUE) 
	{ 
		BOOL fConnected,fSuccess; 
		CHAR chRequest[MAX_PATH]; 
		DWORD cbBytesRead; 
		
		// If Pipe server is stopped break from the loop.
		if(pPipeDlg->m_PipeHandle == NULL)
			break;

		fConnected = ConnectNamedPipe(pPipeDlg->m_PipeHandle, NULL) ? TRUE : (GetLastError() == ERROR_PIPE_CONNECTED); 
		
		if (fConnected) 
		{ 
			fSuccess = ReadFile (pPipeDlg->m_PipeHandle, // handle to pipe 
				chRequest, // buffer to receive data 
				MAX_PATH, // size of buffer 
				&cbBytesRead, // number of bytes read 
				NULL); // not overlapped I/O 
			
			chRequest[cbBytesRead] = '\0';
			CString msg;
			msg.Format("Received string : %s\r\n",chRequest);
			pPipeDlg->ShowLastError(msg);

			FlushFileBuffers(pPipeDlg->m_PipeHandle); 
			DisconnectNamedPipe(pPipeDlg->m_PipeHandle); 
		}
	} 
	return 0;
}

DWORD CPipeSampleDlg::CreatePipeThread()
{
	DWORD dwThreadId = 0;

	m_hPipeThread = ::CreateThread(0, 0, (LPTHREAD_START_ROUTINE)StartPipeThread, this, CREATE_SUSPENDED, &dwThreadId);
	ASSERT(m_hPipeThread);

	::SetThreadPriority(m_hPipeThread,THREAD_PRIORITY_IDLE);

	if( !m_hPipeEvent )
		m_hPipeEvent = ::CreateEvent( NULL, FALSE, FALSE, _T("StartUpdateDirectoryThread") );
	else
		::ResetEvent(m_hPipeEvent);
	
	::ResumeThread(m_hPipeThread);

	return dwThreadId;
}

void CPipeSampleDlg::OnButtonStopServer() 
{
	// TODO: Add your control notification handler code here
	if(m_PipeHandle)
	{
		FlushFileBuffers(m_PipeHandle); 
		DisconnectNamedPipe(m_PipeHandle); 
		CloseHandle(m_PipeHandle); 
		ShowLastError("Server stopped successfully");
		m_PipeHandle = NULL;
	}	
	else
		ShowLastError("Server not running from this instance.");
}

void CPipeSampleDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_Status.SetWindowText(_T(""));
}
